function slugify(text) {
	return text.toString().toLowerCase()
    .replace(/\s+/g, '-')           // Replace spaces with -
    .replace(/[^\w\-]+/g, '')       // Remove all non-word chars
    .replace(/\-\-+/g, '-')         // Replace multiple - with single -
    .replace(/^-+/, '')             // Trim - from start of text
    .replace(/-+$/, '');            // Trim - from end of text
}

function intersect(a, b) {
	var t;
    if (b.length > a.length) t = b, b = a, a = t; // indexOf to loop over shorter
    return a.filter(function (e) {
    	if (b.indexOf(e) !== -1) return true;
    }).filter(function (e, i, c) { // extra step to remove duplicates
    	return c.indexOf(e) === i;
    });
}

function inputHandler() {
	var checkedList = [];
	var $products = $('.products[data-criterias]');

	$('input[name=criteria]').each(function(idx, el) {
		if (el.checked) {
			checkedList.push($(el).data('product-criteria'));
		}
	});

	if (checkedList.length === 0) {
		$products.show(100);
	} else {
		$products.each(function(idx, product) {
			var criteriasList = $(product).data('criterias').split(' ');
			var matchingElements = intersect(checkedList, criteriasList);

			if (matchingElements.length > 0) {
				$(product).show(100);
			} else {
				$(product).hide(100);
			}
		});
	}
}

function clearInputs() {
	var $inputs = $('input[name=criteria]');

	$inputs.each(function(idx, el) {
		if (el.checked) {
			el.checked = false;
		}
	});

	$inputs.trigger('change');
}

function openModal() {
	$('body').addClass('open-modal');
}

function closeModal() {
	$('body').removeClass('open-modal');
	$('.product-iframe').hide();
}

$(function() {
	$('input[name=criteria]').on('change', inputHandler);
	$('#clear-inputs').on('click', clearInputs);

	$('[data-criterias] > a').on('click', function(e) {
		e.preventDefault();

		var iframeSrc = this.href;
		var $iframeContainer = $(this).next('.product-iframe');
		var iframe = $iframeContainer.children('iframe')[0];

		openModal();

		if (iframe.src.length === 0) {
			iframe.src = iframeSrc;
		}
		
		$iframeContainer.show();
	});

	// $('[data-criterias] > a').each(function(idx, link) {
	// 	if (link.href.indexOf('http') > -1) {
			
	// 		// var $iframeContainer = $(link).next('.product-iframe');

	// 		$(link).on('click', function(e) {
	// 		});
	// 	}
	// });

	$('#return-button').on('click', closeModal);
});
