var timer = null;
var prods = 'all';
var cat = 'all';

var resetClick = {
    on: function () {
        $(document).off('click').on('click', function () {
            resetTimer();
        });
        resetTimer();
    },
    off: function () {
        clearInterval(timer);
        timer = null;
        $(document).off('click');
    }
};

var navigation = {
    "setup": function () {
        /* Product tabs/menu click handlers  */
        $('.prodtabs li').each(function () {
            $(this).off().on('click', function () {
                if ($(this).hasClass('reset')) {
                    prods = 'all';
                    cat = 'all';
                    changeContent();
                } else if (!($(this).hasClass('active'))) {
                    prods = getSelector($(this), 'prod');
                    changeContent();
                }
            });
        });

        /* Category menu click handlers  */
        $('.bplist li').each(function () {
            $(this).off().on('click', function () {
                var sel = $(this).hasClass('select');
                if (!sel) {
                    cat = getSelector($(this), 'cat');
                    changeContent();
                }
            });
        });

        /* product click handlers  */
        $('.prodcontainer').each(function () {
            $(this).off().on('click', function () {
                var act = $(this).hasClass('active');
                if (act) {
                    var theurl = $(this).data('url');
                    openProdUrl(theurl);
                }
            });
        });
    }
};

function changeContent() {
    //console.log('prods: ' + prods);
    //console.log('cat: ' + cat);
    $('.noresults').removeClass('active');

    if (prods === 'all' && cat === 'all') {
        $('.bpnav li').removeClass('active');
        $('.bplist li').removeClass('select');
        $('.prodcontainer').addClass('active');
    } else {
        //product menu/tabs setup
        $('.bpnav li:not(.' + prods + ')').removeClass('active');
        $('.bpnav li.' + prods + '').addClass('active');

        //category menu setup
        $('.bpnav li:not(.' + cat + ')').removeClass('select');
        $('.bpnav li.' + cat + '').addClass('select');

        //products setup
        $('.prodcontainer').removeClass('active').promise().done(function () {
            var theprods = (prods === 'all') ? '' : '.' + prods;
            var thecat = (cat === 'all') ? '' : '.' + cat;
            var acprods = $('.prodcontainer' + theprods + thecat);

            acprods.addClass('active').promise().done(function () {
                if (acprods.length === 0) {
                    $('.noresults').addClass('active');
                }
            });
        });
    }
}

function getSelector(elem, id) {
    var sel = '';
    var classes = elem.attr('class').split(' ');

    for (var i = 0; i < classes.length; i++) {
        var sep = classes[i].indexOf('-');
        var cc = classes[i].substring(0, sep);

        if (cc === id) {
            sel = classes[i];
        }
    }
    return sel;
}

function openProdUrl(theurl) {
    //console.log('url: ' + theurl);
    //add no scrolls
    $('#contentwrap, .bplist, .bpcontainer').addClass('noscroll');

    //create html
    var pophtml = '<div id="prodPop" class="prodPop"><div class="closecontain"><img id="popclosebtn" src="images/closebtn.svg" class="closebtn"></div><div class="webcontain"> <iframe id="webframe" class="webframe" src="' + theurl + '" target="_self" sandbox="allow-forms allow-scripts"></iframe></div></div>';

    $('#contentwrap').append(pophtml).promise().done(function () {
        //add close btn listener
        $('#popclosebtn').off().on('click', closeProdUrl);

    });
}

function closeProdUrl() {
    //remove close button listener

    //clear iframe
    $('#webframe').attr('src', '').promise().done(function () {
        //remove html
        $('#prodPop').remove();

        //clear no scrolls
        $('#contentwrap, .bplist, .bpcontainer').removeClass('noscroll');
    });
}

function resetTimer() {
    clearInterval(timer);
    //console.log('10 minutes until page reload');
    timer = setInterval(function () {
        clearInterval(timer);

        // reresh the page
        if (prods !== 'all' || cat !== 'all' || $('#prodPop').length > 0) {
            location.reload();
        }

        resetTimer();

    }, 600000); //10 minutes
    //}, 10000); //10 seconds
}


$(document).ready(function () {
    if (Modernizr.touch) {
        $("body").attr("ontouchstart", "");
    }

    navigation.setup();
    changeContent();

    resetClick.on();
});